@echo off
REM TGIF.BAT uses GIFGATE to test GIF Uploads
REM %1 = Full path and filename of upload (C:\RBBS\UPLOAD\FILENAME.GIF)
REM %2 = Full path and filename of RBBS error flag file

GIFGATE %1 /w640 /h340 /c256 /y90 /g /t /lc:\rbbs\node%node%\gifgate.log

REM GIFGATE ERRORLEVEL Exits
REM The Width, Height, Colors, Size, Year, and Giflite errorlevels exits
REM can all be added up to give a total of 63 possible combination of
REM fails.  The errorlevel exits for each of these parameters are as follows:

REM ERRLEVEL                           SYMBOL IN LABEL
REM  1 - Width Below Minimum           W
REM  2 - Height Below Minimum          H
REM  4 - Colors Below Minimum          C
REM  8 - File Size Below Minimum       S
REM 16 - Year Before Minimum           Y
REM 32 - GifLite'd GIF                 G

REM Even if you do not use ALL of the possible command line switches for
REM GIFGATE, it is reccommended that you leave all the ERRORLEVEL exit
REM routines in this batch file anyway.

IF ERRORLEVEL 255 GOTO UNKNOWN
IF ERRORLEVEL 254 GOTO NOTFOUND
IF ERRORLEVEL 253 GOTO BAD_LOG
IF ERRORLEVEL 250 GOTO BAD_FORMAT
IF ERRORLEVEL 63 GOTO WHCSYG
IF ERRORLEVEL 62 GOTO HCSYG
IF ERRORLEVEL 61 GOTO WCSYG
IF ERRORLEVEL 60 GOTO CSYG
IF ERRORLEVEL 59 GOTO WHSYG
IF ERRORLEVEL 58 GOTO HSYG
IF ERRORLEVEL 57 GOTO WSYG
IF ERRORLEVEL 56 GOTO SYG
IF ERRORLEVEL 55 GOTO WHCYG
IF ERRORLEVEL 54 GOTO HCYG
IF ERRORLEVEL 53 GOTO WCYG
IF ERRORLEVEL 52 GOTO CYG
IF ERRORLEVEL 51 GOTO WHYG
IF ERRORLEVEL 50 GOTO HYG
IF ERRORLEVEL 49 GOTO WYG
IF ERRORLEVEL 48 GOTO YG
IF ERRORLEVEL 47 GOTO WHCSG
IF ERRORLEVEL 46 GOTO HCSG
IF ERRORLEVEL 45 GOTO WCSG
IF ERRORLEVEL 44 GOTO CSG
IF ERRORLEVEL 43 GOTO WHSG
IF ERRORLEVEL 42 GOTO HSG
IF ERRORLEVEL 41 GOTO WSG
IF ERRORLEVEL 40 GOTO SG
IF ERRORLEVEL 39 GOTO WHCG
IF ERRORLEVEL 38 GOTO HCG
IF ERRORLEVEL 37 GOTO WCG
IF ERRORLEVEL 36 GOTO CG
IF ERRORLEVEL 35 GOTO WHG
IF ERRORLEVEL 34 GOTO HG
IF ERRORLEVEL 33 GOTO WG
IF ERRORLEVEL 32 GOTO G
IF ERRORLEVEL 31 GOTO WHCSY
IF ERRORLEVEL 30 GOTO HCSY
IF ERRORLEVEL 29 GOTO WCSY
IF ERRORLEVEL 28 GOTO CSY
IF ERRORLEVEL 27 GOTO WHSY
IF ERRORLEVEL 26 GOTO HSY
IF ERRORLEVEL 25 GOTO WSY
IF ERRORLEVEL 24 GOTO SY
IF ERRORLEVEL 23 GOTO WHCY
IF ERRORLEVEL 22 GOTO HCY
IF ERRORLEVEL 21 GOTO WCY
IF ERRORLEVEL 20 GOTO CY
IF ERRORLEVEL 19 GOTO WHY
IF ERRORLEVEL 18 GOTO HY
IF ERRORLEVEL 17 GOTO WY
IF ERRORLEVEL 16 GOTO Y
IF ERRORLEVEL 15 GOTO WHCS
IF ERRORLEVEL 14 GOTO HCS
IF ERRORLEVEL 13 GOTO WCS
IF ERRORLEVEL 12 GOTO CS
IF ERRORLEVEL 11 GOTO WHS
IF ERRORLEVEL 10 GOTO HS
IF ERRORLEVEL 9 GOTO WS
IF ERRORLEVEL 8 GOTO S
IF ERRORLEVEL 7 GOTO WHC
IF ERRORLEVEL 6 GOTO HC
IF ERRORLEVEL 5 GOTO WC
IF ERRORLEVEL 4 GOTO C
IF ERRORLEVEL 3 GOTO WH
IF ERRORLEVEL 2 GOTO H
IF ERRORLEVEL 1 GOTO W
IF ERRORLEVEL 0 GOTO GOOD_GIF

:UNKNOWN
proecho %node%  ~A Program Error occurred during testing!
proecho %node%  ~Please tell Sysop!~
GOTO BAD_GIF

:NOTFOUND
proecho %node% ~Sorry, your upload was not found!
proecho %node%  ~Please tell Sysop!~
GOTO BAD_GIF

:BAD_LOG
proecho %node% ~Sorry, this upload could not be logged!
proecho %node%  ~Please tell Sysop!~
GOTO BAD_GIF

:BAD_FORMAT
proecho %node%  ~The GIF you Uploaded has a BAD header or is Incomplete!~
GOTO BAD_GIF

:WHCSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HCSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WCSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:CSYG
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WSYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:SYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHCYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HCYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WCYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:CYG
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WYG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:YG
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHCSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HCSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WCSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:CSG
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WSG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:SG
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHCG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HCG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WCG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:CG
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:HG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WG
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:G
proecho %node% ~The GIF you Uploaded has been GIFLITE'd!
proecho %node% ~This BBS does not accept GIF uploads that have been GIFLITE'd!~
GOTO BAD_GIF

:WHCSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:HCSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WCSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:CSY
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WHSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:HSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WSY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:SY
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WHCY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:HCY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WCY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:CY
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WHY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:HY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WY
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:Y
proecho %node% ~The GIF you Uploaded is too OLD!
proecho %node% ~All Uploads MUST be dated 1990 or newer!~
GOTO BAD_GIF

:WHCS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:HCS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:WCS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:CS
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:WHS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:HS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:WS
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:S
proecho %node% ~The GIF you Uploaded is BELOW the minimum requirement for SIZE!
proecho %node% ~All Uploads MUST be at least 30k in Size!~
GOTO BAD_GIF

:WHC
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
GOTO BAD_GIF

:HC
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
GOTO BAD_GIF

:WC
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
GOTO BAD_GIF

:C
proecho %node% ~The GIF you Uploaded is BELOW the mimimum requirements for COLORS!
proecho %node% ~All Uploads MUST have at least 256 colors!~
GOTO BAD_GIF

:WH
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
GOTO BAD_GIF

:H
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for LENGTH!
proecho %node% ~All Uploads MUST be at least 398 pixels in length!~
GOTO BAD_GIF

:W
proecho %node% ~The GIF you Uploaded is BELOW the minimum RESOLUTION for WIDTH!
proecho %node% ~All Uploads MUST be at least 638 pixels wide!~
GOTO BAD_GIF

:BAD_GIF
COPY %1 C:\RBBS\BADFILES
DEL %1
ECHO ERROR > %2
GOTO END

:GOOD_GIF
proecho %node%  ~No Errors Detected!~
IF EXIST NODE%node%\VCHK%node% DEL NODE%node%\VCHK%node%

:END
SETERROR 0
